/***************************************************************************
 * MoioChart Library - graphs and charts made easy                         *
 * Copyright (C) 2005 by Silvio Moioli                                     *
 * silvio@moioli.net, http://www.moioli.net                                *  
 *                                                                         *
 * This program is free software; you can redistribute it and/or           *
 * modify it under the terms of the GNU General Public License             *
 * as published by the Free Software Foundation; either version 2          *
 * of the License, or (at your option) any later version.                  *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * You should have received a copy of the GNU General Public License       *
 * along with this program; if not, write to the Free Software             *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,              *
 * MA  02110-1301, USA.                                                    *
 ***************************************************************************/

package net.moioli.chart.swing;

import swingwt.awt.Color;
import swingwt.awt.Frame;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;

import swingwtx.swing.DefaultListModel;
import swingwtx.swing.table.TableModel;

import net.moioli.drawables.BigPoint;
import net.moioli.drawables.FunctionI;
import net.moioli.drawables.Histogram;
import net.moioli.drawables.ParsedFunction;
import net.moioli.drawables.ParsedPlaneCurve;
import net.moioli.drawables.Pie;

import org.nfunk.jep.ParseException;

/**
 * A NetBeans-generated Swing demo of the MoioChart graph library. <br />
 * Here you'll find pretty everything you can do with MoioChart: multiple
 * function graph, pies, histograms, custom zooming, etc. Most of the code has
 * been automatically generated with NetBeans, so it's not meant to be really
 * readable ;)<br />
 * Anyway the important bits are documented, and should be really easy to
 * understand. If it is not the case, drop me a mail! <br />
 * 
 * @author Silvio Moioli
 * @version 2005/10/5
 */
public class SwingDemo extends swingwtx.swing.JFrame {

    /** Creates new form MainFrame */
    public SwingDemo() {
        initComponents();
        // Put this here because NB 4.0 can't handle this properly
        this.setExtendedState(Frame.MAXIMIZED_BOTH);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    private void initComponents() {// GEN-BEGIN:initComponents
        this.buttonGroup1 = new swingwtx.swing.ButtonGroup();
        this.jTabbedPane1 = new swingwtx.swing.JTabbedPane();
        this.jPanel9 = new swingwtx.swing.JPanel();
        this.jGraph1 = new net.moioli.chart.swing.JGraph();
        this.jPanel1 = new swingwtx.swing.JPanel();
        this.jPanel2 = new swingwtx.swing.JPanel();
        this.jLabel4 = new swingwtx.swing.JLabel();
        this.jTextField1 = new swingwtx.swing.JTextField();
        this.jButton1 = new swingwtx.swing.JButton();
        this.jScrollPane1 = new swingwtx.swing.JScrollPane();
        this.jList1 = new swingwtx.swing.JList();
        this.jButton2 = new swingwtx.swing.JButton();
        this.jPanel3 = new swingwtx.swing.JPanel();
        this.jLabel3 = new swingwtx.swing.JLabel();
        this.jPanel4 = new swingwtx.swing.JPanel();
        this.jLabel1 = new swingwtx.swing.JLabel();
        this.jSlider1 = new swingwtx.swing.JSlider();
        this.jPanel5 = new swingwtx.swing.JPanel();
        this.jLabel2 = new swingwtx.swing.JLabel();
        this.jSlider2 = new swingwtx.swing.JSlider();
        this.jCheckBox1 = new swingwtx.swing.JCheckBox();
        this.jPanel6 = new swingwtx.swing.JPanel();
        this.jLabel5 = new swingwtx.swing.JLabel();
        this.jSlider3 = new swingwtx.swing.JSlider();
        this.jPanel7 = new swingwtx.swing.JPanel();
        this.jLabel6 = new swingwtx.swing.JLabel();
        this.jSlider4 = new swingwtx.swing.JSlider();
        this.jPanel8 = new swingwtx.swing.JPanel();
        this.jButton4 = new swingwtx.swing.JButton();
        this.jButton3 = new swingwtx.swing.JButton();
        this.jButton5 = new swingwtx.swing.JButton();
        this.jButton6 = new swingwtx.swing.JButton();
        this.jPanel10 = new swingwtx.swing.JPanel();
        this.jGraph2 = new net.moioli.chart.swing.JGraph();
        this.jPanel12 = new swingwtx.swing.JPanel();
        this.jLabel7 = new swingwtx.swing.JLabel();
        this.jPanel13 = new swingwtx.swing.JPanel();
        this.jLabel8 = new swingwtx.swing.JLabel();
        this.jTextField2 = new swingwtx.swing.JTextField();
        this.jPanel14 = new swingwtx.swing.JPanel();
        this.jLabel9 = new swingwtx.swing.JLabel();
        this.jTextField3 = new swingwtx.swing.JTextField();
        this.jButton7 = new swingwtx.swing.JButton();
        this.jScrollPane2 = new swingwtx.swing.JScrollPane();
        this.jList2 = new swingwtx.swing.JList();
        this.jButton8 = new swingwtx.swing.JButton();
        this.jPanel15 = new swingwtx.swing.JPanel();
        this.jLabel10 = new swingwtx.swing.JLabel();
        this.jSlider5 = new swingwtx.swing.JSlider();
        this.jPanel16 = new swingwtx.swing.JPanel();
        this.jLabel11 = new swingwtx.swing.JLabel();
        this.jSlider6 = new swingwtx.swing.JSlider();
        this.jPanel11 = new swingwtx.swing.JPanel();
        this.jGraph3 = new net.moioli.chart.swing.JGraph();
        this.jPanel17 = new swingwtx.swing.JPanel();
        this.jScrollPane3 = new swingwtx.swing.JScrollPane();
        this.jTable1 = new swingwtx.swing.JTable();
        this.jPanel18 = new swingwtx.swing.JPanel();
        this.jRadioButton1 = new swingwtx.swing.JRadioButton();
        this.jRadioButton2 = new swingwtx.swing.JRadioButton();

        getContentPane().setLayout(new swingwt.awt.GridLayout(1, 2));

        setDefaultCloseOperation(swingwtx.swing.WindowConstants.EXIT_ON_CLOSE);
        this.setExtendedState(Frame.MAXIMIZED_BOTH);
        this.jTabbedPane1.setTabPlacement(swingwtx.swing.SwingConstants.LEFT);
        this.jPanel9.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jPanel9.add(this.jGraph1);

        this.jPanel1.setLayout(new swingwt.awt.GridLayout(3, 1));

        this.jPanel2.setLayout(new swingwt.awt.GridLayout(5, 1));

        this.jLabel4.setText("Functions");
        this.jPanel2.add(this.jLabel4);

        this.jTextField1.setText("x*sin(x)");
        this.jPanel2.add(this.jTextField1);

        this.jButton1.setText("Add");
        this.jButton1.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        this.jPanel2.add(this.jButton1);

        swingwtx.swing.ListModel lm1 = new swingwtx.swing.DefaultListModel();
        this.jList1.setModel(lm1);
        this.jList1
                .setSelectionMode(swingwtx.swing.ListSelectionModel.SINGLE_SELECTION);
        this.jScrollPane1.setViewportView(this.jList1);

        this.jPanel2.add(this.jScrollPane1);

        this.jButton2.setText("Remove selected");
        this.jButton2.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        this.jPanel2.add(this.jButton2);

        this.jPanel1.add(this.jPanel2);

        this.jPanel3.setLayout(new swingwt.awt.GridLayout(6, 2));

        this.jLabel3.setText("Drawing intervals:");
        this.jPanel3.add(this.jLabel3);

        this.jPanel4.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jLabel1.setText("Minimum x");
        this.jPanel4.add(this.jLabel1);

        this.jSlider1.setMinimum(-101);
        this.jSlider1.setValue(-5);
        this.jSlider1.addChangeListener(new swingwtx.swing.event.ChangeListener() {
            public void stateChanged(swingwtx.swing.event.ChangeEvent evt) {
                jSlider1StateChanged(evt);
            }
        });

        this.jPanel4.add(this.jSlider1);

        this.jPanel3.add(this.jPanel4);

        this.jPanel5.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jLabel2.setText("Maximum x");
        this.jPanel5.add(this.jLabel2);

        this.jSlider2.setMaximum(101);
        this.jSlider2.setMinimum(-100);
        this.jSlider2.setValue(5);
        this.jSlider2.addChangeListener(new swingwtx.swing.event.ChangeListener() {
            public void stateChanged(swingwtx.swing.event.ChangeEvent evt) {
                jSlider2StateChanged(evt);
            }
        });

        this.jPanel5.add(this.jSlider2);

        this.jPanel3.add(this.jPanel5);

        this.jCheckBox1.setSelected(true);
        this.jCheckBox1.setText("y autoscale");
        this.jCheckBox1.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        this.jPanel3.add(this.jCheckBox1);

        this.jPanel6.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jLabel5.setText("Minimum y");
        this.jPanel6.add(this.jLabel5);

        this.jSlider3.setMinimum(-101);
        this.jSlider3.setValue(-1);
        this.jSlider3.setEnabled(false);
        this.jSlider3.addChangeListener(new swingwtx.swing.event.ChangeListener() {
            public void stateChanged(swingwtx.swing.event.ChangeEvent evt) {
                jSlider3StateChanged(evt);
            }
        });

        this.jPanel6.add(this.jSlider3);

        this.jPanel3.add(this.jPanel6);

        this.jPanel7.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jLabel6.setText("Maximum y");
        this.jPanel7.add(this.jLabel6);

        this.jSlider4.setMaximum(101);
        this.jSlider4.setMinimum(-100);
        this.jSlider4.setValue(1);
        this.jSlider4.setEnabled(false);
        this.jSlider4.addChangeListener(new swingwtx.swing.event.ChangeListener() {
            public void stateChanged(swingwtx.swing.event.ChangeEvent evt) {
                jSlider4StateChanged(evt);
            }
        });

        this.jPanel7.add(this.jSlider4);

        this.jPanel3.add(this.jPanel7);

        this.jPanel1.add(this.jPanel3);

        this.jPanel8.setLayout(new swingwt.awt.GridLayout(2, 4));

        this.jButton4.setText("Look for a minimum  (selected function)");
        this.jButton4.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        this.jPanel8.add(this.jButton4);

        this.jButton3.setText("Look for a zero  (selected function)");
        this.jButton3.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        this.jPanel8.add(this.jButton3);

        this.jButton5.setText("Look for a maximum  (selected function)");
        this.jButton5.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        this.jPanel8.add(this.jButton5);

        this.jButton6.setText("Clear BigPoints");
        this.jButton6.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        this.jPanel8.add(this.jButton6);

        this.jPanel1.add(this.jPanel8);

        this.jPanel9.add(this.jPanel1);

        this.jTabbedPane1.addTab("Functions", this.jPanel9);

        this.jPanel10.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jGraph2.setMaxY(5.0);
        this.jGraph2.setMinY(-5.0);
        this.jPanel10.add(this.jGraph2);

        this.jPanel12.setLayout(new swingwt.awt.GridLayout(10, 1));

        this.jLabel7.setText("Curves");
        this.jPanel12.add(this.jLabel7);

        this.jPanel13.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jLabel8.setText("x =");
        this.jPanel13.add(this.jLabel8);

        this.jTextField2.setText("t*cos(5t)");
        this.jPanel13.add(this.jTextField2);

        this.jPanel12.add(this.jPanel13);

        this.jPanel14.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.jLabel9.setText("y = ");
        this.jPanel14.add(this.jLabel9);

        this.jTextField3.setText("t*sin(5t)");
        this.jPanel14.add(this.jTextField3);

        this.jPanel12.add(this.jPanel14);

        this.jButton7.setText("Add");
        this.jButton7.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        this.jPanel12.add(this.jButton7);

        swingwtx.swing.DefaultListModel lm2 = new swingwtx.swing.DefaultListModel();
        this.jList2.setModel(lm2);
        this.jScrollPane2.setViewportView(this.jList2);

        this.jPanel12.add(this.jScrollPane2);

        this.jButton8.setText("Remove");
        this.jButton8.addActionListener(new swingwt.awt.event.ActionListener() {
            public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        this.jPanel12.add(this.jButton8);

        this.jPanel15.setLayout(new swingwt.awt.GridLayout(1, 0));

        this.jLabel10.setText("Maximum t value");
        this.jPanel15.add(this.jLabel10);

        this.jSlider5.setMaximum(200);
        this.jSlider5.setMinimum(1);
        this.jSlider5.setValue(100);
        this.jSlider5.addChangeListener(new swingwtx.swing.event.ChangeListener() {
            public void stateChanged(swingwtx.swing.event.ChangeEvent evt) {
                jSlider5StateChanged(evt);
            }
        });

        this.jPanel15.add(this.jSlider5);

        this.jPanel12.add(this.jPanel15);

        this.jPanel16.setLayout(new swingwt.awt.GridLayout(1, 0));

        this.jLabel11.setText("Zoom");
        this.jPanel16.add(this.jLabel11);

        this.jSlider6.setMinimum(1);
        this.jSlider6.setValue(5);
        this.jSlider6.addChangeListener(new swingwtx.swing.event.ChangeListener() {
            public void stateChanged(swingwtx.swing.event.ChangeEvent evt) {
                jSlider6StateChanged(evt);
            }
        });

        this.jPanel16.add(this.jSlider6);

        this.jPanel12.add(this.jPanel16);

        this.jPanel10.add(this.jPanel12);

        this.jTabbedPane1.addTab("Curves", this.jPanel10);

        this.jPanel11.setLayout(new swingwt.awt.GridLayout(1, 2));

        this.updateJGraph3();
        this.jPanel11.add(this.jGraph3);

        this.jPanel17.setLayout(new swingwt.awt.GridLayout(2, 1));

        this.jTable1.setModel(new swingwtx.swing.table.DefaultTableModel(
                new Object[][] { { "A", new Integer(10) },
                        { "B", new Integer(54) }, { "C", new Integer(84) },
                        { "D", new Integer(12) }, { "E", new Integer(25) } },
                new String[] { "Mark", "Number of students" }) {
            Class[] types = new Class[] { java.lang.String.class,
                    java.lang.Integer.class };

            public Class getColumnClass(int columnIndex) {
                return this.types[columnIndex];
            }
        });
        this.jTable1
                .addPropertyChangeListener(new java.beans.PropertyChangeListener() {
                    public void propertyChange(
                            java.beans.PropertyChangeEvent evt) {
                        jTable1PropertyChange(evt);
                    }
                });

        this.jScrollPane3.setViewportView(this.jTable1);

        this.jPanel17.add(this.jScrollPane3);

        this.jPanel18.setLayout(new swingwt.awt.GridLayout(2, 1));

        this.buttonGroup1.add(this.jRadioButton1);
        this.jRadioButton1.setSelected(true);
        this.jRadioButton1.setText("Pie");
        this.jRadioButton1
                .addActionListener(new swingwt.awt.event.ActionListener() {
                    public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                        jRadioButton1ActionPerformed(evt);
                    }
                });

        this.jPanel18.add(this.jRadioButton1);

        this.buttonGroup1.add(this.jRadioButton2);
        this.jRadioButton2.setText("Histogram");
        this.jRadioButton2
                .addActionListener(new swingwt.awt.event.ActionListener() {
                    public void actionPerformed(swingwt.awt.event.ActionEvent evt) {
                        jRadioButton2ActionPerformed(evt);
                    }
                });

        this.jPanel18.add(this.jRadioButton2);

        this.jPanel17.add(this.jPanel18);

        this.jPanel11.add(this.jPanel17);

        this.jTabbedPane1.addTab("Charts", this.jPanel11);

        getContentPane().add(this.jTabbedPane1);

        pack();
    }// GEN-END:initComponents

    void jTable1PropertyChange(java.beans.PropertyChangeEvent evt) {// GEN-FIRST:event_this.jTable1PropertyChange
        this.updateJGraph3();
    }// GEN-LAST:event_this.jTable1PropertyChange

    void jRadioButton1ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jRadioButton1ActionPerformed
        this.updateJGraph3();
    }// GEN-LAST:event_this.jRadioButton1ActionPerformed

    void jRadioButton2ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jRadioButton2ActionPerformed
        this.updateJGraph3();
    }// GEN-LAST:event_this.jRadioButton2ActionPerformed

    void jSlider6StateChanged(swingwtx.swing.event.ChangeEvent evt) {// GEN-FIRST:event_this.jSlider6StateChanged
        // We want the same x and y scale in this example
        this.jGraph2.setMinX(-5 * this.jSlider6.getValue() * 0.25);
        this.jGraph2.setMinY(-5 * this.jSlider6.getValue() * 0.25);
        this.jGraph2.setMaxX(5 * this.jSlider6.getValue() * 0.25);
        this.jGraph2.setMaxY(5 * this.jSlider6.getValue() * 0.25);
    }// GEN-LAST:event_this.jSlider6StateChanged

    void jSlider5StateChanged(swingwtx.swing.event.ChangeEvent evt) {// GEN-FIRST:event_this.jSlider5StateChanged
        // Check which function is selected
        int si = this.jList2.getSelectedIndex();
        if (si != -1) {
            // Take that function and replace it
            ParsedPlaneCurve f = (ParsedPlaneCurve) this.jList2
                    .getSelectedValue();
            this.jGraph2.remove(f);
            f.setMaxT(2 * Math.PI * this.jSlider5.getValue() / 100.0);
            this.jGraph2.add(f);
        }
    }// GEN-LAST:event_this.jSlider5StateChanged

    void jButton8ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton8ActionPerformed
        // Ensure a function is selected
        int si = this.jList2.getSelectedIndex();
        if (si != -1) {
            // If it is, remove it from the DefaultChart
            Object sv = this.jList2.getSelectedValue();
            this.jGraph2.remove(sv);
            ((DefaultListModel) this.jList2.getModel()).removeElement(sv);
            this.jList2.setSelectedIndex(this.jList2.getModel().getSize() - 1);
        }
    }// GEN-LAST:event_this.jButton8ActionPerformed

    void jButton7ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton7ActionPerformed
        // Ensure strings are in the textfields. If this is not the case, use
        // the red color to alert the user
        if (this.jTextField2.getText().equals("")
                || this.jTextField3.getText().equals("")) {
            this.jTextField2.setBackground(Color.RED);
            this.jTextField3.setBackground(Color.RED);
        } else {
            try {
                // Parse the curve and add it to the DefaultChart
                ParsedPlaneCurve f = new ParsedPlaneCurve(this.jTextField2
                        .getText(), this.jTextField3.getText(), 2 * Math.PI
                        * this.jSlider5.getValue() / 100.0);
                this.jGraph2.add(f);
                ((DefaultListModel) this.jList2.getModel()).addElement(f);
                this.jList2.setSelectedValue(f, true);
                // Everything went fine, restore white background color
                this.jTextField2.setBackground(Color.WHITE);
                this.jTextField3.setBackground(Color.WHITE);
            } catch (ParseException e) {
                // Something's wrong with the parsing
                this.jTextField2.setBackground(Color.RED);
                this.jTextField3.setBackground(Color.RED);
            }
        }
    }// GEN-LAST:event_this.jButton7ActionPerformed

    void jButton6ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton6ActionPerformed
        Iterator i = this.jGraph1.iterator();
        Collection toRemove = new LinkedList();
        // Look at every object in this.this.jGraph1. If the object is a
        // BigPoint,
        // put it in the remove list.
        while (i.hasNext()) {
            Object current = i.next();
            if (current instanceof BigPoint) {
                toRemove.add(current);
            }
        }
        this.jGraph1.removeAll(toRemove);
    }// GEN-LAST:event_this.jButton6ActionPerformed

    void jButton5ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton5ActionPerformed
        // Check the selected function
        int si = this.jList1.getSelectedIndex();
        if (si != -1) {
            // Look for a maximum
            ParsedFunction f = (ParsedFunction) this.jList1.getSelectedValue();
            double begin = this.jGraph1.getMinX();
            double end = this.jGraph1.getMaxX();
            double xP = f.getMaximum(begin, end);
            // Construct a BigPoint and add it to the DefaultChart
            this.jGraph1.add(new BigPoint(xP, f.f(xP), "Maximum at (" + xP
                    + ";" + f.f(xP) + ")"));
        }
    }// GEN-LAST:event_this.jButton5ActionPerformed

    void jButton4ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton4ActionPerformed
        // Check the selected function
        int si = this.jList1.getSelectedIndex();
        if (si != -1) {
            // Look for a minimum
            ParsedFunction f = (ParsedFunction) this.jList1.getSelectedValue();
            double begin = this.jGraph1.getMinX();
            double end = this.jGraph1.getMaxX();
            double xP = f.getMinimum(begin, end);
            // Construct a BigPoint and add it to the DefaultChart
            this.jGraph1.add(new BigPoint(xP, f.f(xP), "Minimum at (" + xP
                    + ";" + f.f(xP) + ")"));
        }
    }// GEN-LAST:event_this.jButton4ActionPerformed

    void jButton3ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton3ActionPerformed
        // Check the selected function
        int si = this.jList1.getSelectedIndex();
        if (si != -1) {
            // Look for a zero
            FunctionI f = (FunctionI) this.jList1.getSelectedValue();
            double begin = this.jGraph1.getMinX();
            double end = this.jGraph1.getMaxX();
            double xP = this.findZero(f, begin, end);
            // Construct a BigPoint and add it to the DefaultChart
            this.jGraph1.add(new BigPoint(xP, f.f(xP), "Zero at " + xP));
        }
    }// GEN-LAST:event_this.jButton3ActionPerformed

    void jSlider4StateChanged(swingwtx.swing.event.ChangeEvent evt) {// GEN-FIRST:event_this.jSlider4StateChanged
        // Ensure the minimum value doesn't exceed or equal the maximum value
        int vs3 = this.jSlider3.getValue();
        int vs4 = this.jSlider4.getValue();
        if (vs4 <= vs3) {
            this.jSlider3.setValue(vs4 - 1);
        }
        this.jGraph1.setMaxY(vs4);
    }// GEN-LAST:event_this.jSlider4StateChanged

    void jSlider3StateChanged(swingwtx.swing.event.ChangeEvent evt) {// GEN-FIRST:event_this.jSlider3StateChanged
        // Ensure the minimum value doesn't exceed or equal the maximum value
        int vs3 = this.jSlider3.getValue();
        int vs4 = this.jSlider4.getValue();
        if (vs3 >= vs4) {
            this.jSlider4.setValue(vs3 + 1);
        }
        this.jGraph1.setMinY(vs3);
    }// GEN-LAST:event_this.jSlider3StateChanged

    void jCheckBox1ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jCheckBox1ActionPerformed
        // Set or unset the auto-scaling
        if (this.jCheckBox1.isSelected() == false) {
            this.jSlider3.setEnabled(true);
            this.jSlider4.setEnabled(true);
            this.jGraph1.setMinY(this.jSlider3.getValue());
            this.jGraph1.setMaxY(this.jSlider4.getValue());
        } else {
            this.jSlider3.setEnabled(false);
            this.jSlider4.setEnabled(false);
            this.jGraph1.setMinY(Double.NaN);
            this.jGraph1.setMaxY(Double.NaN);
        }
    }// GEN-LAST:event_this.jCheckBox1ActionPerformed

    void jSlider2StateChanged(swingwtx.swing.event.ChangeEvent evt) {// GEN-FIRST:event_this.jSlider2StateChanged
        // Ensure the minimum value doesn't exceed or equal the maximum value
        int vs1 = this.jSlider1.getValue();
        int vs2 = this.jSlider2.getValue();
        if (vs2 <= vs1) {
            this.jSlider1.setValue(vs2 - 1);
        }
        this.jGraph1.setMaxX(vs2);
    }// GEN-LAST:event_this.jSlider2StateChanged

    void jSlider1StateChanged(swingwtx.swing.event.ChangeEvent evt) {// GEN-FIRST:event_this.jSlider1StateChanged
        // Ensure the minimum value doesn't exceed or equal the maximum value
        int vs1 = this.jSlider1.getValue();
        int vs2 = this.jSlider2.getValue();
        if (vs1 >= vs2) {
            this.jSlider2.setValue(vs1 + 1);
        }
        this.jGraph1.setMinX(vs1);
    }// GEN-LAST:event_this.jSlider1StateChanged

    void jButton2ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton2ActionPerformed
        // Ensure a function is selected
        int si = this.jList1.getSelectedIndex();
        if (si != -1) {
            // If it is, remove it from the DefaultChart
            Object sv = this.jList1.getSelectedValue();
            this.jGraph1.remove(sv);
            ((DefaultListModel) this.jList1.getModel()).removeElement(sv);
            this.jList1.setSelectedIndex(this.jList1.getModel().getSize() - 1);
        }
    }// GEN-LAST:event_this.jButton2ActionPerformed

    void jButton1ActionPerformed(swingwt.awt.event.ActionEvent evt) {// GEN-FIRST:event_this.jButton1ActionPerformed
        // Parses the string in this.jTextField1 and adds the parsed function
        // to the DefaultChart
        try {
            FunctionI f = new ParsedFunction(this.jTextField1.getText());
            this.jGraph1.add(f);
            ((DefaultListModel) this.jList1.getModel()).addElement(f);
            this.jList1.setSelectedValue(f, true);
            this.jTextField1.setBackground(Color.WHITE);
        } catch (ParseException e) {
            this.jTextField1.setBackground(Color.RED);
        }
    }// GEN-LAST:event_this.jButton1ActionPerformed

    /**
     * @param args
     *            the command line arguments
     */
    public static void     main(String args[]) {    new net.moioli.swtloader.SWTLoader("moiochart-demo-swingwt-mac.jar");             if (swingwtx.swing.SwingWTUtils.isMacOSX()) {        swingwtx.swing.SwingWTUtils.initialiseMacOSX(new Runnable() {                    public void run() {                        SwingDemo.startUp();                    }                });            }            else 
        SwingDemo.startUp();
    }
    
    private static void startUp(){
        swingwt.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SwingDemo().setVisible(true);
            }
        });
    }

    /**
     * Empirically tries to find a zero in the given interval. TODO: move this
     * in the Drawables framework
     * 
     * @param internalFunction
     *            the function to test
     * @param minX
     *            minimum x to start searching
     * @param maxX
     *            maximum x to stop searching
     */
    private double findZero(net.moioli.drawables.FunctionI f, double minX,
            double maxX) {
        if (f.f(minX) > f.f(maxX)) {
            double temp = minX;
            minX = maxX;
            maxX = temp;
        }
        int i = 0;
        while (Math.abs(f.f(minX) - f.f(maxX)) > 0.0001 && i > 1000) {
            if (f.f((minX + maxX) / 2.0) > 0) {
                maxX = (minX + maxX) / 2.0;
            } else {
                minX = (minX + maxX) / 2.0;
            }
            i++;
        }
        return (minX + maxX) / 2.0;
    }

    /**
     * Updates the chart according to the data in this.jTable1 and the radio
     * buttons selection.
     */
    private void updateJGraph3() {
        Map map;
        if (this.jRadioButton1.isSelected()) {
            map = new Pie();
        } else {
            map = new Histogram();
        }
        TableModel tm = this.jTable1.getModel();
        for (int i = 0; i < tm.getRowCount(); i++) {
            map.put(tm.getValueAt(i, 0), tm.getValueAt(i, 1));
        }
        this.jGraph3.clear();
        this.jGraph3.add(map);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private swingwtx.swing.ButtonGroup buttonGroup1;

    private swingwtx.swing.JButton jButton1;

    private swingwtx.swing.JButton jButton2;

    private swingwtx.swing.JButton jButton3;

    private swingwtx.swing.JButton jButton4;

    private swingwtx.swing.JButton jButton5;

    private swingwtx.swing.JButton jButton6;

    private swingwtx.swing.JButton jButton7;

    private swingwtx.swing.JButton jButton8;

    private swingwtx.swing.JCheckBox jCheckBox1;

    private net.moioli.chart.swing.JGraph jGraph1;

    private net.moioli.chart.swing.JGraph jGraph2;

    private net.moioli.chart.swing.JGraph jGraph3;

    private swingwtx.swing.JLabel jLabel1;

    private swingwtx.swing.JLabel jLabel10;

    private swingwtx.swing.JLabel jLabel11;

    private swingwtx.swing.JLabel jLabel2;

    private swingwtx.swing.JLabel jLabel3;

    private swingwtx.swing.JLabel jLabel4;

    private swingwtx.swing.JLabel jLabel5;

    private swingwtx.swing.JLabel jLabel6;

    private swingwtx.swing.JLabel jLabel7;

    private swingwtx.swing.JLabel jLabel8;

    private swingwtx.swing.JLabel jLabel9;

    private swingwtx.swing.JList jList1;

    private swingwtx.swing.JList jList2;

    private swingwtx.swing.JPanel jPanel1;

    private swingwtx.swing.JPanel jPanel10;

    private swingwtx.swing.JPanel jPanel11;

    private swingwtx.swing.JPanel jPanel12;

    private swingwtx.swing.JPanel jPanel13;

    private swingwtx.swing.JPanel jPanel14;

    private swingwtx.swing.JPanel jPanel15;

    private swingwtx.swing.JPanel jPanel16;

    private swingwtx.swing.JPanel jPanel17;

    private swingwtx.swing.JPanel jPanel18;

    private swingwtx.swing.JPanel jPanel2;

    private swingwtx.swing.JPanel jPanel3;

    private swingwtx.swing.JPanel jPanel4;

    private swingwtx.swing.JPanel jPanel5;

    private swingwtx.swing.JPanel jPanel6;

    private swingwtx.swing.JPanel jPanel7;

    private swingwtx.swing.JPanel jPanel8;

    private swingwtx.swing.JPanel jPanel9;

    private swingwtx.swing.JRadioButton jRadioButton1;

    private swingwtx.swing.JRadioButton jRadioButton2;

    private swingwtx.swing.JScrollPane jScrollPane1;

    private swingwtx.swing.JScrollPane jScrollPane2;

    private swingwtx.swing.JScrollPane jScrollPane3;

    private swingwtx.swing.JSlider jSlider1;

    private swingwtx.swing.JSlider jSlider2;

    private swingwtx.swing.JSlider jSlider3;

    private swingwtx.swing.JSlider jSlider4;

    private swingwtx.swing.JSlider jSlider5;

    private swingwtx.swing.JSlider jSlider6;

    private swingwtx.swing.JTabbedPane jTabbedPane1;

    private swingwtx.swing.JTable jTable1;

    private swingwtx.swing.JTextField jTextField1;

    private swingwtx.swing.JTextField jTextField2;

    private swingwtx.swing.JTextField jTextField3;
    // End of variables declaration//GEN-END:variables

}
